Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 766)
@@ -925,19 +1061,30 @@
 c
       REAL zphi(klon,klev)
-      REAL zx_relief(iim,jjmp1)
-      REAL zx_aire(iim,jjmp1)
+cym A voir plus tard !!
+cym      REAL zx_relief(iim,jjmp1)
+cym      REAL zx_aire(iim,jjmp1)
 c
 cIM cf. AM Variables locales pour la CLA (hbtm2)
 c
-      REAL pblh(klon, nbsrf)           ! Hauteur de couche limite
-      REAL plcl(klon, nbsrf)           ! Niveau de condensation de la CLA
-      REAL capCL(klon, nbsrf)          ! CAPE de couche limite
-      REAL oliqCL(klon, nbsrf)          ! eau_liqu integree de couche limite
-      REAL cteiCL(klon, nbsrf)          ! cloud top instab. crit. couche limite
-      REAL pblt(klon, nbsrf)          ! T a la Hauteur de couche limite
-      REAL therm(klon, nbsrf)
-      REAL trmb1(klon, nbsrf)          ! deep_cape
-      REAL trmb2(klon, nbsrf)          ! inhibition 
-      REAL trmb3(klon, nbsrf)          ! Point Omega
+      REAL,SAVE,ALLOCATABLE :: pblh(:, :)           ! Hauteur de couche limite
+c$OMP THREADPRIVATE(pblh)
+      REAL,SAVE,ALLOCATABLE :: plcl(:, :)           ! Niveau de condensation de la CLA
+c$OMP THREADPRIVATE(plcl)
+      REAL,SAVE,ALLOCATABLE :: capCL(:, :)          ! CAPE de couche limite
+c$OMP THREADPRIVATE(capCL)
+      REAL,SAVE,ALLOCATABLE :: oliqCL(:, :)          ! eau_liqu integree de couche limite
+c$OMP THREADPRIVATE(oliqCL)
+      REAL,SAVE,ALLOCATABLE :: cteiCL(:, :)          ! cloud top instab. crit. couche limite
+c$OMP THREADPRIVATE(cteiCL)
+      REAL,SAVE,ALLOCATABLE :: pblt(:, :)          ! T a la Hauteur de couche limite
+c$OMP THREADPRIVATE(pblt)
+      REAL,SAVE,ALLOCATABLE :: therm(:, :)
+c$OMP THREADPRIVATE(therm)
+      REAL,SAVE,ALLOCATABLE :: trmb1(:, :)          ! deep_cape
+c$OMP THREADPRIVATE(trmb1)
+      REAL,SAVE,ALLOCATABLE :: trmb2(:, :)          ! inhibition 
+c$OMP THREADPRIVATE(trmb2)
+      REAL,SAVE,ALLOCATABLE :: trmb3(:, :)          ! Point Omega
+c$OMP THREADPRIVATE(trmb3)
 c Grdeurs de sorties
       REAL s_pblh(klon), s_lcl(klon), s_capCL(klon)
@@ -952,12 +1099,15 @@
       REAL dnwd0(klon,klev)     ! unsaturated downdraft mass flux
       REAL tvp(klon,klev)       ! virtual temp of lifted parcel
-      REAL cape(klon)           ! CAPE
-      SAVE cape
+      REAL,allocatable,save :: cape(:)           ! CAPE
+c$OMP THREADPRIVATE(cape)
+cym      SAVE cape
       CHARACTER*40 capemaxcels  !max(CAPE)
 
-      REAL pbase(klon)          ! cloud base pressure
-      SAVE pbase
-      REAL bbase(klon)          ! cloud base buoyancy
-      SAVE bbase
+      REAL,allocatable,save :: pbase(:)          ! cloud base pressure
+c$OMP THREADPRIVATE(pbase)
+cym      SAVE pbase
+      REAL,allocatable,save :: bbase(:)          ! cloud base buoyancy
+c$OMP THREADPRIVATE(bbase)
+cym      SAVE bbase
       REAL rflag(klon)          ! flag fonctionnement de convect
       INTEGER iflagctrl(klon)          ! flag fonctionnement de convect
@@ -982,5 +1132,6 @@
 c vdf: couche limite (Vertical DiFfusion)
       REAL d_t_con(klon,klev),d_q_con(klon,klev)
-      REAL d_u_con(klon,klev),d_v_con(klon,klev)
+      REAL,SAVE,ALLOCATABLE :: d_u_con(:,:),d_v_con(:,:)
+c$OMP THREADPRIVATE(d_u_con,d_v_con)
       REAL d_t_lsc(klon,klev),d_q_lsc(klon,klev),d_ql_lsc(klon,klev)
       REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
@@ -992,6 +1143,7 @@
 *********************************************************
 *     declarations
-      real zqasc(klon,klev)
-      save zqasc
+      real,save,allocatable :: zqasc(:,:)
+c$OMP THREADPRIVATE(zqasc)
+cym      save zqasc
       
 *********************************************************
@@ -1005,10 +1157,15 @@
       REAL prfl(klon,klev+1), psfl(klon,klev+1)
 c
-      INTEGER ibas_con(klon), itop_con(klon)
+      INTEGER,allocatable,save :: ibas_con(:), itop_con(:)
+c$OMP THREADPRIVATE(ibas_con,itop_con)
 cym
-      SAVE ibas_con,itop_con
+cym      SAVE ibas_con,itop_con
 cym
-      REAL rain_con(klon), rain_lsc(klon)
-      REAL snow_con(klon), snow_lsc(klon)
+      REAL,SAVE,ALLOCATABLE :: rain_con(:)
+c$OMP THREADPRIVATE(rain_con)
+      REAL rain_lsc(klon)
+      REAL,SAVE,ALLOCATABLE :: snow_con(:)
+c$OMP THREADPRIVATE(snow_con)
+      REAL snow_lsc(klon)
       REAL d_ts(klon,nbsrf)
 c
@@ -1022,7 +1179,11 @@
       REAL d_u_oli(klon,klev), d_v_oli(klon,klev) !tendances dues a oro et lif 
 
-      REAL ratqs(klon,klev),ratqss(klon,klev),ratqsc(klon,klev)
+      REAL,allocatable,save :: ratqs(:,:)
+c$OMP THREADPRIVATE(ratqs)
+      REAL ratqss(klon,klev),ratqsc(klon,klev)
       real ratqsbas,ratqshaut
-      save ratqsbas,ratqshaut, ratqs
+cym      save ratqsbas,ratqshaut, ratqs
+      save ratqsbas,ratqshaut
+c$OMP THREADPRIVATE(ratqsbas,ratqshaut)
       real zpt_conv(klon,klev)
 
@@ -1032,10 +1193,12 @@
       logical ok_newmicro
       save ok_newmicro
+c$OMP THREADPRIVATE(ok_newmicro)
       save fact_cldcon,facttemps
+c$OMP THREADPRIVATE(fact_cldcon,facttemps)
       real facteur
 
       integer iflag_cldcon
       save iflag_cldcon
-
+c$OMP THREADPRIVATE(iflag_cldcon)
       logical ptconv(klon,klev)
 cIM cf. AM 081204 BEG
@@ -1051,4 +1214,5 @@
       integer imin_ins,imax_ins,jmin_ins,jmax_ins
       save imin_ins,imax_ins,jmin_ins,jmax_ins
+c$OMP THREADPRIVATE(imin_ins,imax_ins,jmin_ins,jmax_ins)
 c      real lonmin_ins,lonmax_ins,latmin_ins
 c     s  ,latmax_ins
@@ -1087,4 +1251,5 @@
       REAL tabcntr0( length       )
 c
+
       INTEGER ndex2d(iim*jjmp1),ndex3d(iim*jjmp1*klev)
 cIM
@@ -1102,4 +1267,5 @@
       INTEGER ij, imp1jmp1
       PARAMETER(imp1jmp1=(iim+1)*jjmp1)
+cym A voir plus tard
       REAL zx_tmp(imp1jmp1), airedyn(iim+1,jjmp1)
       REAL padyn(iim+1,jjmp1,klev+1)
@@ -1111,13 +1277,15 @@
 cIM 
       REAL airetot, pi
-      REAL zm_wo(jjmp1, klev)
+cym A voir plus tard
+cym      REAL zm_wo(jjmp1, klev)
 cIM AMIP2 END
 c
       REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
       REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
-#ifdef histmthNMC
-      REAL zx_tmp_NC(iim,jjmp1,nlevSTD)
+c#ifdef histmthNMC
+cym   A voir plus tard !!!!
+cym      REAL zx_tmp_NC(iim,jjmp1,nlevSTD)
       REAL zx_tmp_fiNC(klon,nlevSTD) 
-#endif
+c#endif
       REAL*8 zx_tmp2_fi3d(klon,klev) ! variable temporaire pour champs 3D 
       REAL zx_tmp_2d(iim,jjmp1), zx_tmp_3d(iim,jjmp1,klev)
@@ -1128,8 +1296,11 @@
       SAVE nid_day, nid_mth, nid_ins, nid_nmc, nid_day_seri
       SAVE nid_ctesGCM
+c$OMP THREADPRIVATE(nid_day, nid_mth, nid_ins, nid_nmc)
+c$OMP THREADPRIVATE(nid_day_seri,nid_ctesGCM)
 c
 cIM 280405 BEG
       INTEGER nid_bilKPins, nid_bilKPave
       SAVE nid_bilKPins, nid_bilKPave
+c$OMP THREADPRIVATE(nid_bilKPins, nid_bilKPave)
 c
       REAL ve_lay(klon,klev) ! transport meri. de l'energie a chaque niveau vert.
@@ -1146,7 +1317,9 @@
       REAL zout_isccp(napisccp)
       SAVE zcals, zcalh, zoutj, zout_isccp
+c$OMP THREADPRIVATE(zcals, zcalh, zoutj, zout_isccp)
 
       real zjulian
       save zjulian
+c$OMP THREADPRIVATE(zjulian)
 
       character*20 modname
@@ -1172,11 +1345,20 @@
       SAVE      h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot
      $        , h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot
+c$OMP THREADPRIVATE(h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot,
+c$OMP+              h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot)
       REAL      d_h_vcol, d_h_dair, d_qt, d_qw, d_ql, d_qs, d_ec
       REAL      d_h_vcol_phy
       REAL      fs_bound, fq_bound
       SAVE      d_h_vcol_phy
+c$OMP THREADPRIVATE(d_h_vcol_phy)
       REAL      zero_v(klon)
       CHARACTER*15 ztit
-
+      INTEGER   ip_ebil  ! PRINT level for energy conserv. diag.
+      SAVE      ip_ebil
+      DATA      ip_ebil/0/
+c$OMP THREADPRIVATE(ip_ebil)
+      INTEGER   if_ebil ! level for energy conserv. dignostics
+      SAVE      if_ebil
+c$OMP THREADPRIVATE(if_ebil)
 c+jld ec_conser
       REAL d_t_ec(klon,klev)    ! tendance du a la conersion Ec -> E thermique
@@ -1184,6 +1366,8 @@
 c-jld ec_conser
 cIM: t2m, q2m, u10m, v10m et t2mincels, t2maxcels
-      REAL t2m(klon,nbsrf), q2m(klon,nbsrf)   !temperature, humidite a 2m
-      REAL u10m(klon,nbsrf), v10m(klon,nbsrf) !vents a 10m
+      REAL,SAVE,ALLOCATABLE :: t2m(:,:), q2m(:,:)   !temperature, humidite a 2m
+c$OMP THREADPRIVATE(t2m,q2m)
+      REAL,SAVE,ALLOCATABLE :: u10m(:,:), v10m(:,:) !vents a 10m
+c$OMP THREADPRIVATE(u10m,v10m)
       REAL zt2m(klon), zq2m(klon)             !temp., hum. 2m moyenne s/ 1 maille
       REAL zu10m(klon), zv10m(klon)           !vents a 10m moyennes s/1 maille
@@ -1192,6 +1376,7 @@
 cjq   Aerosol effects (Johannes Quaas, 27/11/2003)
       REAL sulfate(klon, klev) ! SO4 aerosol concentration [ug/m3]
-      REAL sulfate_pi(klon, klev) ! SO4 aerosol concentration [ug/m3] (pre-industrial value)
-      SAVE sulfate_pi
+      REAL,allocatable,save :: sulfate_pi(:,:) ! SO4 aerosol concentration [ug/m3] (pre-industrial value)
+c$OMP THREADPRIVATE(sulfate_pi)
+cym      SAVE sulfate_pi
 
       REAL cldtaupi(klon,klev)  ! Cloud optical thickness for pre-industrial (pi) aerosols
@@ -1203,11 +1388,15 @@
 
       ! Aerosol optical properties
-      REAL tau_ae(klon,klev,2), piz_ae(klon,klev,2)
-      REAL cg_ae(klon,klev,2)
-
-      REAL topswad(klon), solswad(klon) ! Aerosol direct effect.
+      REAL,SAVE,ALLOCATABLE :: tau_ae(:,:,:), piz_ae(:,:,:)
+c$OMP THREADPRIVATE(tau_ae,piz_ae)
+      REAL,SAVE,ALLOCATABLE :: cg_ae(:,:,:)
+c$OMP THREADPRIVATE(cg_ae)
+
+      REAL,SAVE,ALLOCATABLE :: topswad(:), solswad(:) ! Aerosol direct effect.
+c$OMP THREADPRIVATE(topswad,solswad)
       ! ok_ade=T -ADE=topswad-topsw
 
-      REAL topswai(klon), solswai(klon) ! Aerosol indirect effect.
+      REAL,SAVE,ALLOCATABLE :: topswai(:), solswai(:) ! Aerosol indirect effect.
+c$OMP THREADPRIVATE(topswai,solswai)
       ! ok_aie=T ->
       !        ok_ade=T -AIE=topswai-topswad
@@ -1221,45 +1410,12 @@
 cym 
       SAVE ok_ade, ok_aie, bl95_b0, bl95_b1
-cym
-c Anne
-         SAVE u10m
-         SAVE v10m
-         SAVE t2m
-         SAVE q2m
-         SAVE ffonte
-         SAVE fqcalving
-         SAVE piz_ae
-         SAVE tau_ae
-         SAVE cg_ae
-         SAVE rain_con
-         SAVE snow_con
-         SAVE topswai
-         SAVE topswad
-         SAVE solswai
-         SAVE solswad
-         SAVE d_u_con
-         SAVE d_v_con
-         SAVE rnebcon0
-         SAVE clwcon0
-         SAVE paire_ter
-c        SAVE nhistoW
-c        SAVE histoW
-c SAVE anne 20/09/2005
-         SAVE pblh
-         SAVE plcl
-         SAVE capCL
-         SAVE oliqCL
-         SAVE cteiCL
-         SAVE pblt
-         SAVE therm
-         SAVE trmb1
-         SAVE trmb2
-         SAVE trmb3
-
-c fin Anne
-cjq-end
+c$OMP THREADPRIVATE(ok_ade, ok_aie, bl95_b0, bl95_b1)
+
 c
 c Declaration des constantes et des fonctions thermodynamiques
 c
+      REAL Field_tmp(klon2,klevp1)
+      LOGICAL,SAVE :: first=.true.
+c$OMP THREADPRIVATE(first)
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1273,5 +1429,158 @@
 c
 c======================================================================
-      modname = 'physiq'
+
+cym => necessaire pour iflag_con != 2    
+      pmfd(:,:) = 0.
+      pen_u(:,:) = 0.
+      pen_d(:,:) = 0.
+      pde_d(:,:) = 0.
+      pde_u(:,:) = 0.
+      aam=0.
+      torsfc=0.
+cym => pour le couple ocean => revoir dans clmain/intersurf
+      fluxg(:)=0.
+      fluxo(:)=0.      
+
+      if (first) then 
+      
+      allocate( t_ancien(klon,klev), q_ancien(klon,klev))
+      allocate( q2(klon,klev+1,nbsrf))
+      allocate( swdn0(klon,klevp1), swdn(klon,klevp1))
+      allocate( swup0(klon,klevp1), swup(klon,klevp1))
+      allocate( SWdn200clr(klon), SWdn200(klon))
+      allocate( SWup200clr(klon), SWup200(klon))
+      allocate( lwdn0(klon,klevp1), lwdn(klon,klevp1))
+      allocate( lwup0(klon,klevp1), lwup(klon,klevp1))
+      allocate( LWdn200clr(klon), LWdn200(klon))
+      allocate( LWup200clr(klon), LWup200(klon))
+      allocate( LWdnTOA(klon), LWdnTOAclr(klon))
+      allocate( radsol(klon))
+      allocate( rlat(klon))
+      allocate( rlon(klon))
+      allocate( ftsol(klon,nbsrf))
+      allocate( ftsoil(klon,nsoilmx,nbsrf))
+      allocate( fevap(klon,nbsrf))
+      allocate( fluxlat(klon,nbsrf))
+      allocate( deltat(klon))
+      allocate( fqsurf(klon,nbsrf))
+      allocate( qsol(klon))
+      allocate( fsnow(klon,nbsrf))
+      allocate( falbe(klon,nbsrf))
+      allocate( falblw(klon,nbsrf))
+      allocate( zmea(klon))
+      allocate( zstd(klon))
+      allocate( zsig(klon))
+      allocate( zgam(klon))
+      allocate( zthe(klon))
+      allocate( zpic(klon))
+      allocate( zval(klon))
+      allocate( rugoro(klon))
+      allocate( zuthe(klon),zvthe(klon))
+      allocate( agesno(klon,nbsrf))
+      allocate( alb_neig(klon))
+      allocate( run_off_lic_0(klon))
+      allocate( ema_workcbmf(klon))   
+      allocate( ema_cbmf(klon)) 
+      allocate( ema_pcb(klon))
+      allocate( ema_pct(klon))  
+      allocate( Ma(klon,klev) )
+      allocate( qcondc(klon,klev))  
+      allocate( ema_work1(klon, klev), ema_work2(klon, klev))
+      allocate( wd(klon) )
+      allocate( pfrac_impa(klon,klev))
+      allocate( pfrac_nucl(klon,klev))
+      allocate( pfrac_1nucl(klon,klev))
+      allocate( rain_fall(klon) )
+      allocate( snow_fall(klon) )
+      allocate( total_rain(klon), nday_rain(klon))
+      allocate( dlw(klon)   )
+      allocate( fder(klon) )
+      allocate( frugs(klon,nbsrf) )
+      allocate( pctsrf(klon,nbsrf))
+      allocate( albsol(klon))
+      allocate( albsollw(klon))
+      allocate( wo(klon,klev))
+      allocate( clwcon(klon,klev),rnebcon(klon,klev))
+      allocate( heat(klon,klev)    )
+      allocate( heat0(klon,klev)  )
+      allocate( cool(klon,klev)    )
+      allocate( cool0(klon,klev)   )
+      allocate( topsw(klon), toplw(klon), solsw(klon), sollw(klon))
+      allocate( sollwdown(klon)    )
+      allocate( sollwdownclr(klon)  ) 
+      allocate( toplwdown(klon)      )
+      allocate( toplwdownclr(klon)   )
+      allocate( topsw0(klon), toplw0(klon), solsw0(klon), sollw0(klon))
+      allocate( albpla(klon))
+      allocate( cape(klon)   )        
+      allocate( pbase(klon)   )     
+      allocate( bbase(klon)    )     
+      allocate( ibas_con(klon), itop_con(klon))
+      allocate( ratqs(klon,klev))
+      allocate( sulfate_pi(klon, klev)) 
+      allocate( paire_ter(klon))
+      allocate(tsumSTD(klon,nlevSTD,nout))
+      allocate(usumSTD(klon,nlevSTD,nout))
+      allocate(vsumSTD(klon,nlevSTD,nout))
+      allocate(wsumSTD(klon,nlevSTD,nout))
+      allocate(phisumSTD(klon,nlevSTD,nout))
+      allocate(qsumSTD(klon,nlevSTD,nout))
+      allocate(rhsumSTD(klon,nlevSTD,nout))
+      allocate(uvsumSTD(klon,nlevSTD,nout))
+      allocate(vqsumSTD(klon,nlevSTD,nout))
+      allocate(vTsumSTD(klon,nlevSTD,nout))
+      allocate(wqsumSTD(klon,nlevSTD,nout))
+      allocate( vphisumSTD(klon,nlevSTD,nout))
+      allocate( wTsumSTD(klon,nlevSTD,nout))
+      allocate( u2sumSTD(klon,nlevSTD,nout))
+      allocate( v2sumSTD(klon,nlevSTD,nout))
+      allocate( T2sumSTD(klon,nlevSTD,nout))
+      allocate( seed_old(klon,napisccp))
+      allocate( pct_ocean(klon,nbregdyn))
+      allocate( rlonPOS(klon))
+      allocate( newsst(klon))
+      allocate( zqasc(klon,klev))
+      allocate( therm(klon, nbsrf))
+      allocate( rain_con(klon))
+      allocate( pblt(klon, nbsrf))
+      allocate( t2m(klon,nbsrf), q2m(klon,nbsrf) )  
+      allocate( u10m(klon,nbsrf), v10m(klon,nbsrf)) 
+      allocate( topswad(klon), solswad(klon))
+      allocate( topswai(klon), solswai(klon) )
+      allocate( ffonte(klon,nbsrf))
+      allocate( fqcalving(klon,nbsrf))
+      allocate( fqfonte(klon,nbsrf)) 
+      allocate( pblh(klon, nbsrf))
+      allocate( plcl(klon, nbsrf))  
+      allocate( capCL(klon, nbsrf))   
+      allocate( oliqCL(klon, nbsrf))       
+      allocate( cteiCL(klon, nbsrf))       
+      allocate( trmb1(klon, nbsrf))   
+      allocate( trmb2(klon, nbsrf))     
+      allocate( trmb3(klon, nbsrf)) 
+      allocate( clwcon0(klon,klev),rnebcon0(klon,klev))
+      allocate( tau_ae(klon,klev,2), piz_ae(klon,klev,2))
+      allocate( cg_ae(klon,klev,2))
+      allocate( snow_con(klon))
+      allocate( tnondef(klon,nlevSTD,nout)) 
+      allocate( d_u_con(klon,klev),d_v_con(klon,klev))            
+      
+      
+        paire_ter(:)=0.    
+        clwcon(:,:)=0.
+	rnebcon(:,:)=0.
+	ratqs(:,:)=0.
+	run_off_lic_0(:)=0.
+	sollw(:)=0.
+	ema_work1(:,:)=0.
+	ema_work2(:,:)=0.
+cym Attention pbase pas initialise dans concvl !!!!
+        pbase(:)=0
+	
+	first=.false.
+      endif 
+
+                  
+       modname = 'physiq'
 cIM
       IF (ip_ebil_phy.ge.1) THEN
@@ -1305,4 +1614,5 @@
          ffonte(:,:)=0.
          fqcalving(:,:)=0.
+	 fqfonte(:,:)=0.
          piz_ae(:,:,:)=0.
          tau_ae(:,:,:)=0.
@@ -1378,4 +1688,13 @@
      .       run_off_lic_0)
 
+       DO i=1,klon
+         IF ( abs( pctsrf(i, is_ter) + pctsrf(i, is_lic) + 
+     $       pctsrf(i, is_oce) + pctsrf(i, is_sic)  - 1.) .GT. EPSFRA) 
+     $       THEN 
+             WRITE(*,*) 'physiq : pb sous surface au point ', i, 
+     $           pctsrf(i, 1 : nbsrf)
+         ENDIF 
+      ENDDO
+ 
 c   ATTENTION : il faudra a terme relire q2 dans l'etat initial
          q2(:,:,:)=1.e-8
@@ -1583,4 +1902,5 @@
 #endif
 
+c#include "ini_histday_seri.h"
 #include "ini_histday_seri.h"
 
@@ -1606,4 +1926,6 @@
 c
 #ifdef INCA
+           call VTe(VTphysiq)
+	   call VTb(VTinca)
            iii = MOD(NINT(xjour),360)
            calday = FLOAT(iii) + gmtime
@@ -1612,5 +1934,5 @@
            WRITE(lunout,*) 'Appel CHEMINI ...'
 #endif
-           CALL chemini( rpi,
+           CALL chemini( 
      $                   rg,
      $                   ra,
@@ -1628,4 +1950,6 @@
            WRITE(lunout,*) 'OK.'
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #endif
 c
@@ -1865,6 +2189,6 @@
        DO nsrf = 1, nbsrf
        DO i = 1, klon
-c$$$        fsollw(i,nsrf) = sollwdown(i) - RSIGMA*ftsol(i,nsrf)**4
-c$$$        fsollw(i,nsrf) = sollw(i)
+c@$$        fsollw(i,nsrf) = sollwdown(i) - RSIGMA*ftsol(i,nsrf)**4
+c@$$        fsollw(i,nsrf) = sollw(i)
          fsollw(i,nsrf) = sollw(i)
      $      + 4.0*RSIGMA*ztsol(i)**3 * (ztsol(i)-ftsol(i,nsrf))
@@ -1872,7 +2196,24 @@
        ENDDO
        ENDDO
-
+      
+cYM   !!!!!!!!!!!!!!!!!!!!!!!!!!!!
+cYM         Attention verrue
+cYM    ---> A supprimer plus tard       
+cYM         pour etre integre dans
+cYM         ORCHIDEE       
+      DO i = 1, klon
+        sollwdown(i)=sollw(i)+RSIGMA*ztsol(i)**4
+      ENDDO
+cYM  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
+      
       fder = dlw
 
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+  
       IF (check) THEN
        amn=MIN(tslab(1),1000.)
@@ -1906,5 +2247,5 @@
      s            pblh,capCL,oliqCL,cteiCL,pblT,
      s            therm,trmb1,trmb2,trmb3,plcl,
-     s            fqcalving, ffonte, run_off_lic_0,
+     s            fqcalving, fqfonte,ffonte, run_off_lic_0,
 cIM "slab" ocean
      s            fluxo, fluxg, tslab, seaice) 
@@ -1948,4 +2289,13 @@
       ENDDO
       ENDDO
+
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+
+
 cIM
       IF (ip_ebil_phy.ge.2) THEN 
@@ -1975,4 +2325,5 @@
          zxffonte(i) = 0.0
          zxfqcalving(i) = 0.0
+	 zxfqfonte(i) = 0.0
 cIM cf. AM 081204 BEG
 c
@@ -2016,4 +2367,6 @@
             zxfqcalving(i) = zxfqcalving(i) + 
      .                      fqcalving(i,nsrf)*pctsrf(i,nsrf)
+            zxfqfonte(i) = zxfqfonte(i) + 
+     .                      fqfonte(i,nsrf)*pctsrf(i,nsrf)
 cIM cf. AM 081204 BEG
             s_pblh(i) = s_pblh(i) + pblh(i,nsrf)*pctsrf(i,nsrf)
@@ -2054,4 +2407,5 @@
            ffonte(i,nsrf) = zxffonte(i)
            fqcalving(i,nsrf) = zxfqcalving(i)
+           fqfonte(i,nsrf) = zxfqfonte(i)
            pblh(i,nsrf)=s_pblh(i)
            plcl(i,nsrf)=s_lcl(i)
@@ -2168,4 +2522,10 @@
           ENDIF ! ok_cvl
 
+c
+c Correction precip
+          rain_con = rain_con * cvl_corr
+          snow_con = snow_con * cvl_corr
+c
+
            IF (.NOT. ok_gust) THEN
            do i = 1, klon
@@ -2229,4 +2589,12 @@
         ENDDO
       ENDDO
+
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+
 cIM
       IF (ip_ebil_phy.ge.2) THEN 
@@ -2429,4 +2797,12 @@
      s      , fs_bound, fq_bound )
       END IF 
+
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+
 c
 c-------------------------------------------------------------------
@@ -2477,5 +2853,5 @@
       ELSE IF (iflag_cldcon.eq.3) THEN
 c  On prend pour les nuages convectifs le max du calcul de la
-c  convection et du calcul du pas de temps précédent diminué d'un facteur
+c  convection et du calcul du pas de temps precedent diminue d'un facteur
 c  facttemps
 c      facttemps=pdtphys/1.e4
@@ -2491,4 +2867,23 @@
          enddo
       enddo
+
+c
+cjq - introduce the aerosol direct and first indirect radiative forcings
+cjq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
+      IF (ok_ade.OR.ok_aie) THEN
+         ! Get sulfate aerosol distribution
+         CALL readsulfate(rjourvrai, debut, sulfate)
+         CALL readsulfate_preind(rjourvrai, debut, sulfate_pi)
+
+         ! Calculate aerosol optical properties (Olivier Boucher)
+         CALL aeropt(pplay, paprs, t_seri, sulfate, rhcl,
+     .        tau_ae, piz_ae, cg_ae, aerindex)
+cym
+      ELSE
+        tau_ae(:,:,:)=0.0
+	piz_ae(:,:,:)=0.0
+	cg_ae(:,:,:)=0.0
+cym     
+      ENDIF
 
 c
@@ -2607,29 +3002,14 @@
      . EXP((Lheat *qsat2m(i))/(RCPD*zt2m(i)))
       ENDDO
-c
-cjq - introduce the aerosol direct and first indirect radiative forcings
-cjq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
-      IF (ok_ade.OR.ok_aie) THEN
-         ! Get sulfate aerosol distribution
-         CALL readsulfate(rjourvrai, debut, sulfate)
-         CALL readsulfate_preind(rjourvrai, debut, sulfate_pi)
-
-         ! Calculate aerosol optical properties (Olivier Boucher)
-         CALL aeropt(pplay, paprs, t_seri, sulfate, rhcl,
-     .        tau_ae, piz_ae, cg_ae, aerindex)
-cym
-      ELSE
-        tau_ae(:,:,:)=0.0
-	piz_ae(:,:,:)=0.0
-	cg_ae(:,:,:)=0.0
-cym     
-      ENDIF
+
 
 #ifdef INCA
+      call VTe(VTphysiq)
+      call VTb(VTinca)
            calday = FLOAT(julien) + gmtime
 
 #ifdef INCA_AER
-      call AEROSOL_METEO_CALC(calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs,
-     &   prfl,psfl,pctsrf(1,3),airephy,xjour,rlat,rlon)
+      call AEROSOL_METEO_CALC(calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs
+     &   ,prfl,psfl,pctsrf,airephy,xjour,rlat,rlon,u10m,v10m)
 #endif
 
@@ -2684,4 +3064,6 @@
            WRITE(lunout,*)'OK.'
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #endif
 c     
@@ -2722,4 +3104,12 @@
      .               + falblw(i,is_sic) * pctsrf(i,is_sic)
       ENDDO
+
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+      
       CALL radlwsw ! nouveau rayonnement (compatible Arpege-IFS)
      e            (dist, rmu0, fract, 
@@ -2750,4 +3140,12 @@
       ENDDO
       ENDDO
+c
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+ 
 cIM
       IF (ip_ebil_phy.ge.2) THEN 
@@ -2837,4 +3235,11 @@
       ENDIF ! fin de test sur ok_orodr
 c
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+      
       IF (ok_orolf) THEN
 c
@@ -2872,4 +3277,11 @@
 C STRESS NECESSAIRES: TOUTE LA PHYSIQUE
 
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+
       DO i = 1, klon
         zustrph(i)=0.
@@ -2887,11 +3299,14 @@
 cIM calcul composantes axiales du moment angulaire et couple des montagnes
 c
-      CALL aaam_bud (27,klon,klev,rjourvrai,gmtime,
-     C               ra,rg,romega,
-     C               rlat,rlon,pphis,
-     C               zustrdr,zustrli,zustrph,
-     C               zvstrdr,zvstrli,zvstrph,
-     C               paprs,u,v,
-     C               aam, torsfc)
+      IF (monocpu) THEN
+      
+        CALL aaam_bud (27,klon,klev,rjourvrai,gmtime,
+     C                 ra,rg,romega,
+     C                 rlat,rlon,pphis,
+     C                 zustrdr,zustrli,zustrph,
+     C                 zvstrdr,zvstrli,zvstrph,
+     C                 paprs,u,v,
+     C                 aam, torsfc)
+       ENDIF
 cIM cf. FLott END
 cIM
@@ -3058,4 +3473,6 @@
 c
 #ifdef INCA
+      call VTe(VTphysiq)
+      call VTb(VTinca)
 #ifdef INCAINFO
            WRITE(lunout,*)'Appel CHEMHOOK_END ...'
@@ -3068,15 +3485,13 @@
      $                        nbtr,
      $                        paprs,
-#ifdef INCA_CH4
      $                        q_seri,
-#endif
      $                        annee_ref,
      $                        day_ini,
+     $                        airephy,      
 #ifdef INCA_AER
      $                        xjour,
      $                        pphi,
      $                        pphis,
-     $                        zx_rh,
-     $                        qx(1,1,1))
+     $                        zx_rh)
 #else
      $                        xjour)
@@ -3085,4 +3500,6 @@
            WRITE(lunout,*)'OK.'
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #endif
 
@@ -3091,4 +3508,11 @@
 c Convertir les incrementations en tendances
 c
+      if (mydebug) then
+        call writefield_phy('u_seri',u_seri,llm)
+        call writefield_phy('v_seri',v_seri,llm)
+        call writefield_phy('t_seri',t_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
+      endif
+
       DO k = 1, klev
       DO i = 1, klon
